	IFND GMS_GAMES_I
GMS_GAMES_I  SET  1

**
**	$VER: games.i 0.5 (15.02.97)
**
**      (C) Copyright 1996-1997 DreamWorld Productions.
**          All Rights Reserved
**

	IFND    EXEC_TYPES_I
	include 'exec/types.i'
	ENDC

LIST =		"LIST"      ;Used to indicate a list start.
OBJECTLIST =	"OLST"      ;Used to indicate an object list start.
SKIPENTRY =	0           ;Used to skip to the next entry.
ENDLIST =	-1          ;Used to terminate a list.
LISTEND =	-1          ;Synonym for ENDLIST.
TAGEND  =	0           ;Used to terminate a tag list.

*****************************************************************************
* Universal errorcodes returned by certain functions.  These are further
* explained in the autodoc.

ERR_OK    =    0            ;Function went OK.
ERR_NOMEM =    1            ;Not enough memory available.
ERR_NOPTR =    2            ;A required address pointer is not present.
ERR_INUSE =    3            ;Previous allocations have not been freed.
ERR_STRUCT =   4            ;Structure version not supported/not found.
ERR_FAILED =   5            ;General/Miscellaneous failure.
ERR_FILE =     6            ;File error, eg file not found, disk full etc.
ERR_DATA =     7            ;There is an error in the given data.
ERR_SEARCH =   8            ;An internal search was performed and it failed.
ERR_SCRTYPE =  9            ;Screen Type not recognised.
ERR_GPI =     10            ;Trouble with initialising/using a GPI.

ERR_SUCCESS =  ERR_OK       ;Synonym for ERR_OK.

*****************************************************************************
* Memory types used by AllocMemBlock().  This is almost identical to the
* exec definition but CHIP is renamed to VIDEO (displayable memory) and
* there is an addition of BLIT and SOUND specific memory.  CLEARed memory is
* redundant (all GMS memory is cleared on allocation), REVERSE and NO_EXPUNGE
* are also unused.

MEM_ANY   = $00000000
MEM_CLEAR = MEM_ANY
MEM_VIDEO = $00000002
MEM_BLIT  = $00000004
MEM_SOUND = $00000008

MEMB_PUBLIC =	0               ;Public access memory.
MEMB_VIDEO =	1               ;Displayable memory, blitter compatible.
MEMB_BLIT =	2               ;Blitter memory.
MEMB_SOUND =	3               ;Sound memory.

*****************************************************************************
* Helpful macros and structures.

   STRUCTURE	ListPixel,00
	WORD	PXL_XCoord
	WORD	PXL_YCoord
	LONG	PXL_Colour
	LABEL	PXL_SIZEOF

PIXEL	MACRO
	dc.w	\1,\2
	dc.l	\3
	ENDM

SKIPPIXEL =	-32000

*****************************************************************************
* Universal JoyBits returned from ReadJoyStick, Sega, JoyPad, etc...

JT_SWITCH =	0
JT_ZBXY =	1

JS_LEFT	=	0           ;X axis
JS_RIGHT =	1
JS_UP =		2           ;Y axis
JS_DOWN	=	3
JS_ZIN =	4           ;Z axis!  Reserved for later...
JS_ZOUT =	5
JS_FIRE1 =	6           ;Standard Fire Button (1).
JS_FIRE2 =	7           ;Standard Fire Button (2).
JS_FIRE3 =	11          ;Standard Fire Button (3).

JS_RED =	6           ;CD32 Fire button (1).
JS_BLUE =	7           ;CD32 Fire button (2).
JS_PLAY =	8           ;Other CD32 buttons here.
JS_RWD =	9
JS_FFW =	10
JS_GREEN =	11          ;CD32 Fire button (3).
JS_YELLOW =	12

;Bits for the ZBXY style return type (analogue joysticks)           

JB_FIRE1 =	16
JB_FIRE2 =	17
JB_FIRE3 =	18

MB_LMB	=	16
MB_RMB	=	17
MB_MMB	=	18

;Joyport names for calling Read_JoyStick/Mouse/JoyPad...()

JPORT1	=	0*2
JPORT2	=	1*2
JPORT3	=	2*2         ;<- Works for standard Joysticks only.
JPORT4	=	3*2         ;<- Works for standard Joysticks only.

*****************************************************************************
* GPI ID numbers.

GPI_SCREENS =	0
GPI_BLITTER =	4
GPI_SOUND =	8
GPI_NETWORK =	12
GPI_VECTORS =	16
GPI_DEBUG =	20
GPI_ANIM =	24
GPI_REKO =	28
GPI_TEXT =	32
GPI_OBJECTS =	36

*****************************************************************************
* Standard screen structure.

GSV1 =	("GS"<<16)|00
GSV2 =	("GS"<<16)|01

    STRUCTURE	GameScreen,0
	ULONG	GS_VERSION        ;Version, GSV1.
	APTR	GS_Stats          ;Reserved.
	APTR	GS_MemPtr1        ;Ptr to screen 1
	APTR	GS_MemPtr2        ;Ptr to screen 2 (doubled buffer)
	APTR	GS_MemPtr3        ;Ptr to screen 3 (tripled buffer)
	APTR	GS_ScreenLink     ;Ptr to a linked screen.
	APTR	GS_Palette        ;Ptr to the screen palette.
	APTR	GS_RasterList     ;Ptr to a raster list (or not).
	ULONG	GS_AmtColours     ;The amount of colours on screen.
	UWORD	GS_ScrWidth       ;The width of the visible screen window.
	UWORD	GS_ScrHeight      ;The height of the visible screen window.
	UWORD	GS_PicWidth       ;The width of the screen picture (pixels).
	LABEL	GS_BytesPerRow    ;Synonym of GS_PicByteWidth.
	LABEL	GS_ByteWidth      ;Synonym of GS_PicByteWidth.
	UWORD	GS_PicByteWidth   ;The width of the screen picture (bytes).
	UWORD	GS_PicHeight      ;The height of the screen picture.
	UWORD	GS_Planes         ;The amount of planes in the screen.
	WORD	GS_ScrXOffset     ;Hardware co-ordinate for TOS.
	WORD	GS_ScrYOffset     ;Hardware co-ordinate for LOS.
	UWORD	GS_PicXOffset     ;Offset of the horizontal axis.
	UWORD	GS_PicYOffset     ;Offset of the vertical axis.
	ULONG	GS_Attrib         ;Special Attributes are?
	UWORD	GS_ScrMode        ;What screen mode is it?
	UWORD	GS_ScrType        ;Interleaved/Planar/Chunky?
	LABEL	GSV1_SIZEOF

;Screen Buffer names, these are asked for in the blitter functions.

BUFFER1 = GS_MemPtr1
BUFFER2 = GS_MemPtr2
BUFFER3 = GS_MemPtr3

;Screen types (flags for SS_ScrType).

INTERLEAVED =	1           ;Interleaved (2 ... 256 colours)
ILBM =		1           ;Short synonym of Interleaved.
PLANAR =	2           ;Planar (2 ... 256 colours)
CHUNKY8 =	3           ;Chunky 8 bit (256 colours)
CHUNKY16 =	4           ;Chunky 16 bit (65535 colours)
TRUECOLOUR =	5           ;True colour (16 million colours)

;---------------------------------------------------------------------------;
;Screen attributes/options (flags and bits for GS_ScrAttrib).

DBLBUFFER =	$00000001   ;For double buffering.
TPLBUFFER =	$00000002   ;Triple buffering!!
PLAYFIELD =	$00000004   ;Set if it's part of a playfield.
HSCROLL =	$00000008   ;Gotta set this to do scrolling.
VSCROLL =	$00000010   ;For vertical scrolling.
SPRITES =	$00000020   ;Set this if you want sprites.
SBUFFER =	$00000040   ;Create a scroll buffer for up to 100 screens.
CENTRE =	$00000080   ;Centre the screen (sets ScrXOffset/ScrYOffset).
BLKBDR =	$00000100   ;Gives a blackborder on AGA machines.
NOSCRBDR =	$00000200   ;For putting sprites in the border.
GETSCRMODE =	$00000400   ;Copy user viewmode to GS_ScrMode.

B_DBLBUFFER =	0
B_TPLBUFFER =	1
B_PLAYFIELD =	2
B_HSCROLL =	3
B_VSCROLL =	4
B_SPRITES =	5
B_SBUFFER =	6
B_CENTRE =	7
B_BLKBDR =	8
B_NOSCRBDR =	9
B_GETSCRMODE =	10

;---------------------------------------------------------------------------;
;Screen modes (flags for GS_ScrMode).

LORES =		$0000       ;Low resolution (default).
HIRES =		$0001       ;High resolution.
SHIRES =	$0002       ;Super-High resolution.
LACED =		$0004       ;Interlaced.
; =		$0008       ;Low resolution.
EXTRAHB =	$0010       ;Set for extra half-brite.
; =		$0020
HAM =		$0040       ;For HAM mode.
COL12BIT =	$0080       ;12 bit colour.
COL24BIT =	$0000       ;24 bit colour (default).

B_HIRES =	0
B_SHIRES =	1
B_LACED =	2
B_EXTRAHB =	4
B_HAM =		6
B_COL12BIT =	7
;B_COL24BIT =	7

;---------------------------------------------------------------------------;
;Screen Attribute tags.

TBYTE =	0
TWORD =	(1<<30)
TLONG =	(1<<31)
TAPTR =  TLONG|(1<<29)

GSA_MemPtr1 =      GS_MemPtr1|TAPTR
GSA_MemPtr2 =      GS_MemPtr2|TAPTR
GSA_MemPtr3 =      GS_MemPtr3|TAPTR
GSA_ScreenLink =   GS_ScreenLink|TAPTR
GSA_Palette =      GS_Palette|TAPTR
GSA_RasterList =   GS_RasterList|TAPTR
GSA_AmtColours =   GS_AmtColours|TLONG
GSA_ScrWidth =     GS_ScrWidth|TWORD
GSA_ScrHeight =    GS_ScrHeight|TWORD
GSA_PicByteWidth = GS_PicByteWidth|TWORD
GSA_PicHeight =    GS_PicHeight|TWORD
GSA_Planes =       GS_Planes|TWORD
GSA_ScrXOffset =   GS_ScrXOffset|TWORD
GSA_ScrYOffset =   GS_ScrYOffset|TWORD
GSA_PicXOffset =   GS_PicXOffset|TWORD
GSA_PicYOffset =   GS_PicYOffset|TWORD
GSA_Attrib =       GS_Attrib|TLONG
GSA_ScrMode =      GS_ScrMode|TWORD
GSA_ScrType =      GS_ScrType|TWORD

*****************************************************************************
*
* Raster/Copper commands for RasterLists.
*
* Examples of how to use these commands/macros in a rasterlist:
*
* COL12      <ColourNumber>,<$0RGB>
* COL24      <ColourNumber>,<$00RRGGBB>
* COL12LIST  <StartLine>,<Skip>,<Colour>,<ColourList>
* COL24LIST  <StartLine>,<SKip>,<Colour>,<ColourList>
* SPRITE     <SpriteStruct>
* SCROLL     <Fields>,<PixelOffset 0-16>,<PixelQuarterOffset 1-4>
* FLOOD      
* REPOINT    <BitplanePtr>
* MIRROR     
* NEWPALETTE <ColStart>,<AmtCols>,<Palette>
* WAITLINE   <Line>
* RASTEND
*
* Warn: With colour related commands you must use the same amount of colour
* bits as specified in your GameScreen structure (COL12BIT or COL24BIT)

COL12Len =	12             ;COL12,Colour,RGB
COL24Len =	16             ;COL24,Colour,RRGGBB
COL12LISTLen =	16             ;COL12LIST,Line,Skip,Colour,RGB
COL24LISTLen =	16             ;COL24LIST,Line,Skip,Colour,RRGGBB
SPRITELen =	12             ;SPRITE,SpriteStruct
SCROLLLen =	8              ;SCROLL,Offset
FSCROLLLen =	16             ;FSCROLL,Offset
FLOODLen =	8              ;FLOOD
REPOINTLen =	12             ;REPOINT,BitPtr
MIRRORLen =	8              ;MIRROR
NEWPALETTELen = 20             ;NEWPALETTE,ColStart,AmtCols,Palette
WAITLINELen =	8              ;WAITLINE,Line

COL12	MACRO   ;<ColourNumber>,<$RGB>
	dc.w	00,\1,\2,0
	dc.l	0
	ENDM

COL24	MACRO   ;<ColourNumber>,<$RRGGBB>
	dc.w	02,0
	dc.l	\1
	dc.l	\2
	dc.l	0
	ENDM

COL12LIST MACRO	;<Line> <Skip> <Colour> <ColourList>
	dc.w	04,\1,\2,\3
	dc.l	\4
	dc.l	0
	ENDM

COL24LIST MACRO	;<Line> <Skip> <Colour> <ColourList>
	dc.w	06,\1,\2,\3
	dc.l	\4
	dc.l	0
	ENDM

SPRITE	MACRO   ;<SpriteStruct>
	dc.w	08,0
	dc.l	\1
	dc.l	0
	ENDM

SCROLL	MACRO   ;<Fields>,<PixelOffset (0..16)>
	dc.w	10,\1,\2,\3
	dc.l	0
	ENDM

FSCROLL	MACRO   ;<Fields>,<PixelOffset (0..16)>,<(0..4)>
	dc.w	12,\1,\2,\3,\4,0
	dc.l	0
	ENDM

FLOOD	MACRO	;<>
	dc.w	14,0
	dc.l	0
	ENDM

REPOINT	MACRO   ;<BitplanePtr>
	dc.w	16,0
	dc.l	\2
	dc.l	0
	ENDM

MIRROR	MACRO	;<>
	dc.w	18,0
	dc.l	0
	ENDM

NEWPALETTE MACRO ;<ColStart>,<AmtCols>,<Palette>
	dc.w	20,0
	dc.l	\1
	dc.l	\2
	dc.l	\3
	dc.l	0
	ENDM

WAITLINE MACRO	;<Line>
	dc.w	22,\1
	dc.l	0
	ENDM

RASTEND	MACRO
	dc.l	-1
	ENDM

*****************************************************************************
* Sprite structure

SPV1 =	("SP"<<16)|00

    STRUCTURE	SPR,0
	ULONG	SPR_VERSION       ;Structure version, SPV1.
	APTR	SPR_Stats         ;Reserved.
	UWORD	SPR_Number        ;Sprite bank number.
	APTR	SPR_Data          ;Pointer to Sprite graphic.
	LABEL	SPR_XPos
	WORD	SPR_XCoord        ;X position (screen relative).
	LABEL	SPR_YPos
	WORD	SPR_YCoord        ;Y position (screen relative).
	UWORD	SPR_Frame         ;Current frame number.
	UWORD	SPR_Width         ;Width in pixels.
	UWORD	SPR_Height        ;Height in pixels.
	UWORD	SPR_AmtColours    ;4/16
	UWORD	SPR_ColStart      ;000/016/032/064/096/128/160/192/224
	UWORD	SPR_Planes        ;2/4
	UWORD	SPR_ScrMode       ;HIRES/LORES/SHIRES/XLONG
	UWORD	SPR_FieldPri      ;Playfield position/priority.
	UWORD	SPR_Attrib        ;Sprite attributes.
	LABEL	SPV1_SIZEOF

;Extra stuff for the SPR_Resolution field.

XLONG =    $0001                  ;Double the width (uses extra bank). 

*****************************************************************************
* BOB structure for BBV1, also used as a skeleton for BMV1.

BBV1 =	("BB"<<16)|00

    STRUCTURE	BOB,0
	ULONG	BOB_VERSION       ;Structure version, BBV1.
	APTR	BOB_Stats         ;Private.
	APTR	BOB_GfxData       ;Pointer to BOB graphics.
	APTR	BOB_MaskData      ;Pointer to BOB masks.
	UWORD	BOB_Frame         ;Current frame.
	APTR	BOB_FrameList     ;Pointer to frame list.
	WORD	BOB_SrcWidth      ;Source Page Width in bytes.
	UWORD	BOB_Width         ;Width in pixels (true width).
	UWORD	BOB_ByteWidth     ;Width in bytes (round up).
	UWORD	BOB_Height        ;Height in pixels.
	LABEL	BOB_XCoord        ;X pixel destination.
	WORD	BOB_XPos          ;Synonym of BOB_XCoord.
	LABEL	BOB_YCoord        ;Y pixel destination.
	WORD	BOB_YPos          ;Synonym of BOB_YCoord.
	UWORD	BOB_ClipLX        ;Left X border in bytes.
	UWORD	BOB_ClipTY        ;Top Y border.
	UWORD	BOB_ClipRX        ;Right X border in bytes.
	UWORD	BOB_ClipBY        ;Bottom Y border.
	UWORD	BOB_FPlane        ;First plane to blit to (planar only)
	UWORD	BOB_Planes        ;Amount of planes
	ULONG	BOB_PlaneSize     ;Size Of Plane Source (planar only)
	ULONG	BOB_Attrib        ;Attributes like CLIP and MASK.
	APTR	BOB_Picture       ;Pointer to a picture struct (bob origin).
	LABEL	BBV1_SIZEOF

BBA_GfxData =   BOB_GfxData|TAPTR
BBA_MaskData =  BOB_MaskData|TAPTR
BBA_Frame =     BOB_Frame|TWORD
BBA_FrameList = BOB_FrameList|TAPTR
BBA_SrcWidth =  BOB_SrcWidth|TWORD
BBA_Width =     BOB_Width|TWORD
BBA_ByteWidth = BOB_ByteWidth|TWORD
BBA_Height =    BOB_Height|TWORD
BBA_XCoord =    BOB_XCoord|TWORD
BBA_YCoord =    BOB_YCoord|TWORD
BBA_ClipLX =    BOB_ClipLX|TWORD
BBA_ClipTY =    BOB_ClipTY|TWORD
BBA_ClipRX =    BOB_ClipRX|TWORD
BBA_ClipBY =    BOB_ClipBY|TWORD
BBA_FPlane =    BOB_FPlane|TLONG
BBA_Planes =    BOB_Planes|TWORD
BBA_PlaneSize = BOB_PlaneSize|TLONG
BBA_Attrib =    BOB_Attrib|TLONG
BBA_Picture =   BOB_Picture|TAPTR

*****************************************************************************
* MBOB structure for MBV1, based on BBV1.

MBV1 =	("MB"<<16)|01

    STRUCTURE	MBOB,0          ;MB structure, almost identical to BB.
	ULONG	MB_VERSION      ;Structure version, BMV1.
	APTR	MB_Stats        ;Private.
	APTR	MB_GfxData      ;Pointer to BOB graphics.
	APTR	MB_MaskData     ;Pointer to BOB masks.
	UWORD	MB_AmtEntries   ;Amount of entries in the image list.
	APTR	MB_FrameList    ;Pointer to an image list.
	WORD	MB_SrcWidth     ;Source Page Width in bytes.
	UWORD	MB_Width        ;Width in pixels.
	UWORD	MB_ByteWidth    ;Width in bytes.
	UWORD	MB_Height       ;Height in pixels.
	APTR	MB_EntryList    ;Pointer to the entry/image list.
	UWORD	MB_ClipLX       ;Left X border in bytes.
	UWORD	MB_ClipTY       ;Top Y border.
	UWORD	MB_ClipRX       ;Right X border in bytes.
	UWORD	MB_ClipBY       ;Bottom Y border.
	UWORD	MB_FPlane       ;First plane to blit to (planar only)
	UWORD	MB_Planes       ;Amount of planes.
	ULONG	MB_PlaneSize    ;Size Of Plane Source (planar only)
	ULONG	MB_Attrib       ;Attributes like CLIP and MASK.
	APTR	MB_Picture      ;Pointer to a picture struct (bob origin).
	UWORD	MB_EntrySize    ;Size of each entry.
	LABEL	MBV1_SIZEOF

   STRUCTURE	BE,0            ;MBOB Entry Structure.
	WORD	BE_XCoord
	WORD	BE_YCoord
	UWORD	BE_Frame
	LABEL	BE_SIZEOF

SKIPIMAGE =	32000

MBA_VERSION =	 MB_VERSION|TLONG
MBA_GfxData =	 MB_GfxData|TAPTR
MBA_MaskData =	 MB_MaskData|TAPTR
MBA_AmtEntries = MB_AmtEntries|TWORD
MBA_FrameList =	 MB_FrameList|TAPTR
MBA_SrcWidth =	 MB_SrcWidth|TWORD
MBA_Width =	 MB_Width|TWORD
MBA_ByteWidth =  MB_ByteWidth|TWORD
MBA_Height =	 MB_Height|TWORD
MBA_EntryList =  MB_EntryList|TAPTR
MBA_ClipLX =	 MB_ClipLX|TWORD
MBA_ClipTY =	 MB_ClipTY|TWORD
MBA_ClipRX =	 MB_ClipRX|TWORD
MBA_ClipBY =	 MB_ClipBY|TWORD
MBA_FPlane =	 MB_FPlane|TWORD
MBA_Planes =	 MB_Planes|TWORD
MBA_PlaneSize =	 MB_PlaneSize|TLONG
MBA_Attrib =	 MB_Attrib|TLONG
MBA_Picture =	 MB_Picture|TAPTR
MBA_EntrySize =	 MB_EntrySize|TWORD

;---------------------------------------------------------------------------;
;Drawing Methods and Options for both BOB structures (BOB_Attrib).

CLIP =      $00000001   ;Allow border clipping.
MASK =      $00000002   ;Allow masking.
FILLMASK =  $00000004   ;Fill any holes in the mask on generation.
CLEAR =     $00000008   ;Allow automatic clearing.
RESTORE =   $00000010   ;Allow automatic background restore.
DIRECT =    $00000020   ;Using direct graphics and mask pointers.
CLRMASK =   $00000040   ;Use masks in the clear.
GENMASKS =  $00000082   ;Create and use masks for drawing this BOB.
CLRNOMASK = $00000000   ;Do not use masks in the clear (default).

GENMASK =   GENMASKS     ;Synonym.
FILLMASKS = FILLMASK     ;Synonym.
GENFMASK =  GENMASK|FILLMASK

B_CLIP = 	0
B_MASK = 	1
B_FILLMASK =	2
B_CLEAR =	3
B_RESTORE =	4
B_DIRECT =	5
B_CLRMASK =	6
B_GENMASKS =	7

*****************************************************************************
* Map structure

MPV1 =	("MP"<<16)|00

    STRUCTURE	MAP,0
	ULONG	MAP_VERSION       ;The structure version, MPV1.
	ULONG	MAP_Stats         ;Private.
	UWORD	MAP_Buffer        ;Destination buffer.
	UWORD	MAP_Number        ;Map number to access for data.
	APTR	MAP_MapList       ;Pointer to the map datalist (level list).
	LABEL	MAP_RowSize       ;Synonym of MAP_Width.
	UWORD	MAP_Width         ;Total width of map.
	UWORD	MAP_Height        ;Total height of map.
	UWORD	MAP_XStart        ;Get block data starting from X [byte].
	UWORD	MAP_YStart        ;Get block data starting from Y.
	UWORD	MAP_EntrySize     ;Byte/Word.
	ULONG	MAP_EntryMask     ;For special masking.
	UWORD	MAP_TileWidth     ;The width of each tile.
	LABEL	MAP_TileBWidth    ;Synonym for TileByteWidth.
	UWORD	MAP_TileByteWidth ;The bytewidth of each tile.
	UWORD	MAP_TileHeight    ;The height of each tile.
	UWORD	MAP_Options       ;Applicable Map options, eg LOCKED.
	APTR	MAP_Picture       ;Map's graphics picture (compulsory).
	APTR	MAP_File          ;Where to get the map data.
	LABEL	MPV1_SIZEOF

;CLIP =    $0001   ;Blocks require clipping on the X/Y axis.

MAPSIZE_BYTE = 1    ;Entry size is in bytes.
MAPSIZE_WORD = 2    ;Entry size is in words.
MAPSIZE_LONG = 4    ;Entry size is in longs.

	IFND    GMS_SOUND_I
	include 'games/sound.i'
	ENDC

	IFND    GMS_MISC_I
	include 'games/misc.i'
	ENDC

	IFND    GMS_IMAGE_I
	include 'games/image.i'
	ENDC

  ENDC	;GMS_GAMES_I
