#ifndef GMS_IMAGE_H
#define GMS_IMAGE_H TRUE

/*
**	$VER: image.h 0.5 (15.02.97)
**	Includes Release xx.xx
**
**	games library image structures
**
**	(C) Copyright 1996-1997 DreamWorld Productions.
**	    All Rights Reserved
*/

/***************************************************************************
** The picture structure for loading and depacking of pictures
*/

#define PCV1 0x50430000,0

  struct Picture
   {
   ULONG VERSION;     /* Structure version */
   APTR  Stats;       /* Private */
   APTR  Data;        /* Destination or Source */
   UWORD Width;       /* Picture width in pixels */
   UWORD ByteWidth;   /* Picture width in bytes */
   UWORD Height;      /* Height */
   UWORD Planes;      /* Amount of planes */
   ULONG AmtColours;  /* Amount of colours */
   APTR  Palette;     /* Original palette */
   UWORD ScrMode;     /* Intended screen mode for picture */
   UWORD ScrType;     /* Interleaved/Chunky/Planar */
   ULONG Options;     /* GETPALETTE/VIDEOMEM/REMAP */
   BYTE  *File;       /* Filename for this picture, if any */
   };

#define PCA_Data        (8|TAPTR) /* Source */
#define PCA_Width      (12|TWORD) /* Picture width in pixels */
#define PCA_ByteWidth  (14|TWORD) /* Picture width in bytes */
#define PCA_Height     (16|TWORD) /* Picture height */
#define PCA_Planes     (18|TWORD) /* Amount of planes */
#define PCA_AmtColours (20|TLONG) /* Amount of colours */
#define PCA_Palette    (24|TAPTR) /* Ptr to Palette */
#define PCA_ScrMode    (28|TWORD) /* Intended screen mode for picture */
#define PCA_ScrType    (30|TWORD) /* Interleaved/Chunky/Planar */
#define PCA_Options    (32|TLONG) /* Special flags */
#define PCA_File       (36|TAPTR) /* Where this picture comes from */

#define GETPALETTE 0x00000001     /* Allocate/Write out the palette */
#define VIDEOMEM   0x00000002     /* Unpack to/Obtain chipram only */
#define REMAP      0x00000004     /* Allow remapping */
#define GETVMODE   0x00000008     /* Get screen mode attributes */
#define RESIZEX    0x00000010     /* Allow resize on X axis */
#define RESIZEY    0x00000020     /* Allow resize on Y axis */
#define BLITMEM    0x00000040     /* Unpack to blitter mem only */

#define RESIZE     (RESIZEX|RESIZEY)
#define BLITTERMEM BLITMEM

#endif
