;Object Data for the OBJScreen.s demo
;------------------------------------
;This is a data-file, so we must assemble under absolute mode with the
;org directive (no section/executable headers allowed).  In future these
;files will be created with a GUI interface - you might have to wait a little
;while for this!
;
;Of interest to all programmers: DATA and CODE objects may also be specified,
;which can be extremely useful as you might imagine.  Some demos showing
;these features will be available soon.


	INCDIR	"INCLUDES:"
	INCLUDE	"games/games.i"

	ORG	$0
	FILE	"GAMESLIB:data/OBJ.Worm" ;PhxAss directive (file dest)

Objects:
	dc.b	"GOBJ"

;--------------------------------------------------------------------------;

Worm:	dc.l	"STRC"	;Structure ID.
	dc.l	.end	;Offset towards end of the object.
	dc.b	"Worm",0	;Name.
	even
.data	dc.l	BBV1,0	;Structure version.
	dc.l	0,0	;Graphics data.
	dc.w	0	;Current frame.
	dc.l	.Frames	;Pointer to frame list.
	dc.w	0	;Modulo (skip in source) in bytes.
	dc.w	32,0,24	;Width, Width in bytes, Height.
	dc.w	150,150	;X/Y destination.
	dc.w	32,32	;Border restriction LeftX,TopY.
	dc.w	320-32,256-32	;Border restrictions RightX,EndY.
	dc.w	0,0	;Amount of planes.
	dc.l	0	;Size of plane, not required.
	dc.l	GENMASKS|CLIP|RESTORE	;Attributes.
	dc.l	PIC_Bobs	;Picture struct (Bob origin).
.Frames	dc.w	000,000,0,0	;0 X/Y Graphic, X/Y Mask
	dc.w	032,000,0,0	;1 ...
	dc.w	064,000,0,0	;2
	dc.w	096,000,0,0	;3
	dc.w	128,000,0,0	;4
	dc.w	160,000,0,0	;5
	dc.w	192,000,0,0	;6
	dc.w	224,000,0,0	;7
	dc.w	256,000,0,0	;8
	dc.w	288,000,0,0	;9
	dc.w	000,048,0,0	;10
	dc.w	032,048,0,0	;11
	dc.w	064,048,0,0	;12
	dc.l	-1
.end

;--------------------------------------------------------------------------;

BOBPicture:
	dc.l	"STRC"	;Structure ID.
	dc.l	BOBPictureEnd	;Offset towards end of the object.
	dc.b	"BOBPicture",0	;Name.
	even
PIC_Bobs:
	dc.l	PCV1,0	;Version header.
	dc.l	0	;Source data.
	dc.w	0,0,0	;Width, Height.
	dc.w	5	;Amount of Planes.
	dc.l	0	;Amount of colours.
	dc.l	0	;Source palette.
	dc.w	LORES|COL12BIT	;Screen mode.
	dc.w	PLANAR	;Destination
	dc.l	BLITMEM	;Parameters.
	dc.l	.File
.File	dc.b	"GAMESLIB:data/IFF.Rambo",0
	even
BOBPictureEnd:

;--------------------------------------------------------------------------;

SNDRambo:
	dc.l	"STRC"	;Structure ID.
	dc.l	.end	;Offset towards end of the object.
	dc.b	"SNDRambo",0	;Name.
	even
	dc.l	SMV1,0	;Structure version.
	dc.w	CHANNEL1	;Channel to play through.
	dc.w	0	;Priority.
	dc.l	0	;Sample header
	dc.l	0	;Sample address.
	dc.l	0	;Sample length.
	dc.w	OCT_C2S	;Sample period.
	dc.w	100	;Sample volume.
	dc.l	0	;Sound attributes.
	dc.l	.File	;Sound file.
.File	dc.b	"GAMESLIB:data/SND.Rambo",0
	even

.end ;----------------------------------------------------------------------;

Screen:	dc.l	"STRC"	;Structure ID.
	dc.l	.end	;Offset towards end of the object.
	dc.b	"GameScreen",0	;Name.
	even
	dc.l	GSV1,0	;Version header.
	dc.l	0,0,0	;Screen memory 1/2/3.
	dc.l	0	;Screen link.
	dc.l	0	;Address of screen palette.
	dc.l	0	;Address of rasterlist.
	dc.l	0	;Amount of colours in palette.
	dc.w	320,256	;Screen Width and Height.
	dc.w	320,320/8,256	;Picture Width and Height.
	dc.w	5	;Amount of planes.
	dc.w	0,0	;X/Y screen offset.
	dc.w	0,0	;X/Y picture offset.
	dc.l	DBLBUFFER	;Special attributes.
	dc.w	LORES|COL12BIT	;Screen Mode.
	dc.w	PLANAR	;Screen Type

.end ;----------------------------------------------------------------------;

Background:
	dc.l	"STRC"	;Structure ID.
	dc.l	.end	;Offset towards end of the object.
	dc.b	"Background",0	;Name.
	even
	dc.l	PCV1,0	;Version header.
	dc.l	0	;Source data.
	dc.w	320,320/8,256	;Width, Height.
	dc.w	5	;Amount of Planes.
	dc.l	0	;Amount of colours.
	dc.l	0	;Source palette (remap).
	dc.w	LORES|COL12BIT	;Screen mode.
	dc.w	PLANAR	;Destination
	dc.l	GETPALETTE	;Parameters.
	dc.l	.File
.File	dc.b	"GAMESLIB:data/IFF.Pic320",0
	even

.end ;----------------------------------------------------------------------;

	dc.l	"OEND"
