;-------T-------T------------------------T-----------------------------------;
;Wide Scroll
;-----------
;This opens an extra wide picture of 640x256 pixels and scrolls it left
;and right.  Extremely large pictures are *totally* inadequate for games
;such as platformers and shoot'em-ups, because the picture size takes
;up  huge  amounts  of  memory.   However  for games like Skidmarks,
;Lemmings, Monkey Island, etc, such large screens can be a necessity.

	INCDIR	"INCLUDES:"
	INCLUDE	"exec/exec_lib.i"
	INCLUDE	"games/games_lib.i"
	INCLUDE	"games/games.i"

CALL	MACRO
	jsr	_LVO\1(a6)
	ENDM

	SECTION	"WideScroll",CODE

;===========================================================================;
;                             INITIALISE DEMO
;===========================================================================;

Start:	MOVEM.L	A0-A6/D1-D7,-(SP)
	move.l	($4).w,a6
	lea	GMS_Name(pc),a1
	moveq	#$00,d0
	CALL	OpenLibrary
	move.l	d0,GMS_Base
	beq.s	.Error_GMS

	move.l	GMS_Base(pc),a6
	sub.l	a0,a0
	CALL	SetUserPrefs

	lea	Screen(pc),a0
	CALL	AddScreen
	tst.l	d0
	bne.s	.Error_Screen

	lea	Picture(pc),a1
	move.l	GS_MemPtr1(a0),PIC_Data(a1)
	CALL	LoadPic
	tst.w	d0
	bne.s	.Error_Picture

	move.l	PIC_Palette(a1),GS_Palette(a0)
	move.l	PIC_AmtColours(a1),GS_AmtColours(a0)
	CALL	UpdatePalette

	CALL	ShowScreen

	bsr.s	Main

.ReturnToDOS
	move.l	GMS_Base(pc),a6
	lea	Picture(pc),a1
	CALL	FreePic
.Error_Picture
	move.l	GMS_Base(pc),a6
	lea	Screen(pc),a0
	CALL	DeleteScreen
.Error_Screen
	move.l	GMS_Base(pc),a1
	move.l	($4).w,a6
	CALL	CloseLibrary
.Error_GMS
	MOVEM.L	(SP)+,A0-A6/D1-D7
	moveq	#$00,d0
	rts

;===========================================================================;
;                                MAIN LOOP
;===========================================================================;

Main:	moveq	#0,d2
.loop	CALL	WaitSVBL
	tst.w	d2
	bgt.s	.Right

.Left	tst.w	GS_PicXOffset(a0)
	ble.s	.Right
	moveq	#-2,d2
	bra.s	.scroll

.Right	cmp.w	#320,GS_PicXOffset(a0)
	bge.s	.Left
	moveq	#2,d2

.scroll	add.w	d2,GS_PicXOffset(a0)
	CALL	MovePicture

.done	moveq	#JPORT1,d0	;Port 1 (Mouse)
	moveq	#JT_ZBXY,d1
	CALL	ReadJoyPort
	btst	#MB_LMB,d0
	beq.s	.loop
	rts

;===========================================================================;
;                                  DATA
;===========================================================================;

Direction:
	dc.w	0

GMS_Name:
	dc.b	"games.library",0
	even
GMS_Base:
	dc.l	0

AMT_PLANES =	4

Screen:	dc.l	GSV1,0
	dc.l	0,0,0	;Screen_Mem1/2/3
	dc.l	0	;Screen link.
	dc.l	0	;Address of palette
	dc.l	0	;Address of rasterlist.
	dc.l	0	;Amt of colours in palette.
	dc.w	320,256	;Screen Width and Height.
	dc.w	640,640/8,256	;Picture Width, ByteWidth, Height.
	dc.w	AMT_PLANES	;Amt_Planes
	dc.w	0,0	;Top Of Screen, X/Y
	dc.w	0,0	;X/Y offsets.
	dc.l	HSCROLL	;Special attributes.
	dc.w	LORES|COL12BIT	;Screen mode.
	dc.w	ILBM	;Screen type
	even

Picture	dc.l	PCV1,0	;Version header.
	dc.l	0	;Source data.
	dc.w	640,640/8,256	;Width, Height.
	dc.w	AMT_PLANES	;Amount of Planes.
	dc.l	0	;Amount of colours.
	dc.l	0	;Source palette (remap).
	dc.w	LORES|COL12BIT	;Screen mode.
	dc.w	ILBM	;Destination
	dc.l	GETPALETTE	;Parameters.
	dc.l	.File
.File	dc.b	"GAMESLIB:data/IFF.Pic640x256",0
	even
