;Object Data for the OBJScreen.s demo
;------------------------------------
;This is a data-file, so we must assemble under absolute mode with the
;org directive (no section/executable headers allowed).  In future these
;files will be created with a GUI interface - you might have to wait a little
;while for this!
;
;Of interest to all programmers: DATA and CODE objects may also be specified,
;which can be extremely useful as you might imagine.  Some demos showing
;these features will be available soon.


	INCDIR	"INCLUDES:"
	INCLUDE	"games/games.i"

	ORG	$0
	FILE	"GAMESLIB:data/OBJ.Screen" ;PhxAss directive (file dest)

Objects:
	dc.b	"GOBJ"

;---------------------------------------------------------------------------;
;This is the GameScreen.  It is not necessary to set all the fields as the
;demo will grab most of them from the Picture object and write them to
;the GameScreen structure for us.  However, things like screen width/height,
;the attribute flags, and screen offsets must be specified here.

OBJ_GameScreen:
	dc.l	"STRC"	;Structure ID.
	dc.l	.end	;Offset towards end of the object.
	dc.b	"DemoScreen",0	;Name.
	even
	dc.l	GSV1,0
	dc.l	0,0,0	;Screen memory 1/2/3.
	dc.l	0	;Screen link.
	dc.l	0	;Address of palette.
	dc.l	0	;Address of rasterlist.
	dc.l	0	;Amount of colours in palette.
	dc.w	640,256	;Screen Width and Height. 
	dc.w	0,0,0	;Picture Widths and Height.
	dc.w	0	;Amount of planes.
	dc.w	0,0	;X/Y screen offset.
	dc.w	0,0	;X/Y picture offset.
	dc.l	CENTRE	;Special attributes.
	dc.w	0	;Screen mode.
	dc.w	0	;Screen type
.end

;---------------------------------------------------------------------------;
;This picture structure defines how the picture will be loaded in.  You can
;play with things like the resolution, 12 or 24 bit colour, the file name
;and so on.  Deleting the GETPALETTE and VIDEOMEM flags could make the demo
;crash, so you can see that you always have to be careful when editing
;structures on such a low level.

OBJ_Picture:
	dc.l	"STRC"	;Structure ID.
	dc.l	.end	;Offset towards end of the object.
	dc.b	"DemoPicture",0	;Name.
	even
	dc.l	PCV1,0	;Version header.
	dc.l	0	;Source data.
	dc.w	640,0,256	;Width, Height.
	dc.w	4	;Amount of Planes.
	dc.l	16	;Amount of colours.
	dc.l	0	;Source palette.
	dc.w	HIRES|COL12BIT|LACED	;Screen mode.
	dc.w	ILBM	;Screen type.
	dc.l	GETPALETTE|VIDEOMEM	;Parameters.
	dc.l	.file
.file	dc.b	"GAMESLIB:data/IFF.Pic640x256",0
	even
.end
	dc.l	"OEND"
