/*
** HiRes Picture Display
** ---------------------
** Opens a screen of 640x256 pixels in HIRES LACED mode.  You can even
** try SuperHiRes (SHIRES) if you change the appropriate flag in the
** GameScreen structure.
*/

#include <proto/exec.h>
#include <proto/games.h>

struct GMSBase *GMSBase;
extern struct ExecBase *SysBase;

/*=========================================================================*/

void main(void)
{
  struct GameScreen *GameScreen;
  struct Picture *PIC_HiRes;

  if (GMSBase = (struct GMSBase *) OpenLibrary("games.library", 0)) {
   SetUserPrefs(0);
   if (GameScreen = AddScreenTags(TAGS,NULL,
      GSA_Planes,4,
      GSA_ScrMode,HIRES|LACED|COL12BIT,
      GSA_ScrWidth,640,
      GSA_ScrHeight,256,
      GSA_ScrType,ILBM,
      TAGEND)) {

    if (PIC_HiRes = LoadPicTags(TAGS,NULL,
       PCA_Data,GameScreen->MemPtr1,
       PCA_ScrMode,GameScreen->ScrMode,
       PCA_ScrType,GameScreen->ScrType,
       PCA_Options,GETPALETTE,
       PCA_File,"GAMESLIB:data/IFF.Pic640x256",
       TAGEND)) {

       GameScreen->Palette = PIC_HiRes->Palette;
       UpdatePalette(GameScreen);
       ShowScreen(GameScreen);
       WaitLMB();

    FreePic(PIC_HiRes);
    }
   DeleteScreen(GameScreen);
   }
  CloseLibrary((struct Library *)GMSBase);
  }
}

