/* HiRes Picture Display
** ---------------------
** Opens a screen of 640 pixels width in HIRES mode.  You can even try
** SuperHiRes (SHIRES) if you change the appropriate flag in the GameScreen
** structure.
*/

MODULE 'games','games/games'

PROC main()
DEF screen:PTR TO gamescreen, pic:PTR TO picture

   IF gmsbase := OpenLibrary('games.library',0)
      SetUserPrefs(0)
      IF (screen := AddScreen([TAGS,0,
           GSA_SCRWIDTH,640,
           GSA_SCRHEIGHT,256,
           GSA_PLANES,4,
           GSA_SCRMODE,HIRES OR COL12BIT,
           GSA_SCRTYPE,ILBM,
           TAGEND]))

         IF (pic := LoadPic([TAGS,0,
            PCA_DATA,screen.memptr1,
            PCA_WIDTH,640,
            PCA_HEIGHT,256,
            PCA_PLANES,4,
            PCA_SCRMODE,LORES OR COL12BIT,
            PCA_SCRTYPE,ILBM,
            PCA_OPTIONS,GETPALETTE,
            PCA_FILE,'GAMESLIB:data/IFF.Pic640x256',
            TAGEND]))

            screen.palette := pic.palette
            UpdatePalette(screen)
            ShowScreen(screen)
            WaitLMB()
         FreePic(pic)
         ENDIF
      DeleteScreen(screen)
      ENDIF
   CloseLibrary(gmsbase)
   ENDIF
ENDPROC

