/*
** Object Demo
** -----------
** Opens a screen according to the settings in an object file.  See
** asm/UsingObjects/OBJScreen.s for the object definitions.
*/

MODULE 'games','games/games'

PROC main()
  DEF gamescreen:PTR TO gamescreen, picture:PTR TO picture, objbase:LONG

  IF gmsbase := OpenLibrary('games.library',0)
   SetUserPrefs(0);

   IF (objbase := LoadObjectFile('GAMESLIB:data/OBJ.Screen'))
    IF (gamescreen := GetObject(objbase,'DemoScreen'))
     IF (picture := GetObject(objbase,'DemoPicture'))
      IF (LoadPic(picture) = ERR_OK)
         gamescreen.picwidth := picture.width
         gamescreen.picheight := picture.height
         gamescreen.planes := picture.planes
         gamescreen.scrmode := picture.scrmode
         gamescreen.scrtype := picture.scrtype
         gamescreen.memptr1 := picture.data
         gamescreen.palette := picture.palette

         IF (AddScreen(gamescreen) = ERR_OK)
            ShowScreen(gamescreen)
            WaitLMB()
            DeleteScreen(gamescreen)
         ENDIF
       FreePic(picture)
      ENDIF
     ENDIF
    ENDIF
   FreeObjectFile(objbase)
   ENDIF
  CloseLibrary(gmsbase)
  ENDIF
ENDPROC

