/* Sprite example
** --------------
** This example shows you how to set up a 16 colour OCS sprite with a
** doubled X axis (32 pixels width).  Those with hardware experience will
** know that it takes 4 sprite banks to do this successfully in OCS, which
** leaves you with another 4 banks to do with what you will.  You can do
** this same demo in AGA with just 2 banks used.
** 
** The sprite is attached to the mouse, so try moving it around a bit.
*/

MODULE 'games','games/games','exec/memory'

PROC main()
   DEF screen:PTR TO gamescreen, sparkie:PTR TO sprite, zbxy:LONG,
       timer:LONG

   screen  := [
    GSV1,0,              -> GameScreen Version 
    0,0,0,               -> Screen memory 1,2,3. 
    0,                   -> ScreenLink 
    [$000,$000,$000,$000,$000,$000,$000,$000,$000,$688,$466,$344,$CC0,
     $980,$870,$650,$1C2,$050,$B0B,$606,$F20,$910,$BBB,$FFF,$0BF,$068,
     $568,$9BF,$FF0,$EE0,$BA0,$540]:INT, 
    0,                   -> Address of RasterList 
    32,                  -> Amount of colours in palette
    320,256,             -> Screen Width, Height.
    0,0,0,               -> Picture Width, ByteWidth, Height. 
    1,                   -> Amount of planes 
    0,0,                 -> Top Of Screen, X/Y 
    0,0,                 -> X/Y pic offsets 
    SPRITES OR NOSCRBDR, -> Special attributes 
    LORES OR COL12BIT,   -> Screen mode 
    INTERLEAVED          -> Screen type 
   ]:gamescreen;

   sparkie := [
    SPV1,0,  -> Version number
    0,       -> Bank Number 0
    0,       -> Ptr to graphic
    100,100, -> Beginning X/Y positions
    0,       -> Current frame
    16,21,   -> Width, Height
    16,      -> Amt of colours
    16,      -> Colour start in palette
    2,       -> Amt of planes
    LORES,   -> Resolution attributes
    0,       -> Position in relation to playfields
    XLONG
   ]:sprite;

   IF gmsbase := OpenLibrary('games.library',0)
      SetUserPrefs(0)
      IF (AddScreen(screen) = ERR_OK)
         sparkie.data := SmartLoad('GAMESLIB:data/sparkie.raw',0,MEMF_CHIP)
         InitSprite(screen,sparkie)
         UpdateSprite(screen,sparkie)
         ShowScreen(screen)
         zbxy := ReadMouse(JPORT1)

         REPEAT
           IF (timer++ AND $1)
              IF (sparkie.frame = 5) THEN sparkie.frame := 0 ELSE sparkie.frame := sparkie.frame+1
           ENDIF
           zbxy := ReadMouse(JPORT1)
           sparkie.xpos := sparkie.xpos+getZBXYx(zbxy)
           sparkie.ypos := sparkie.ypos+getZBXYy(zbxy)
           WaitSVBL()
           UpdateSprite(screen,sparkie)
         UNTIL !(zbxy AND MB_LMB)

      FreeMemBlock(sparkie.data);
      DeleteScreen(screen)        
      ENDIF
   CloseLibrary(gmsbase)
   ENDIF
ENDPROC

